# coding: utf-8

"""
    Literature Graph Service

    Fetch paper and author data from the Semantic Scholar corpus  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from s2cholar.configuration import Configuration


class PaperInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'paper_id': 'str',
        'url': 'str',
        'title': 'str',
        'venue': 'str',
        'year': 'int',
        'authors': 'list[object]'
    }

    attribute_map = {
        'paper_id': 'paperId',
        'url': 'url',
        'title': 'title',
        'venue': 'venue',
        'year': 'year',
        'authors': 'authors'
    }

    def __init__(self, paper_id=None, url=None, title=None, venue=None, year=None, authors=None, _configuration=None):  # noqa: E501
        """PaperInfo - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._paper_id = None
        self._url = None
        self._title = None
        self._venue = None
        self._year = None
        self._authors = None
        self.discriminator = None

        self.paper_id = paper_id
        if url is not None:
            self.url = url
        if title is not None:
            self.title = title
        if venue is not None:
            self.venue = venue
        if year is not None:
            self.year = year
        if authors is not None:
            self.authors = authors

    @property
    def paper_id(self):
        """Gets the paper_id of this PaperInfo.  # noqa: E501


        :return: The paper_id of this PaperInfo.  # noqa: E501
        :rtype: str
        """
        return self._paper_id

    @paper_id.setter
    def paper_id(self, paper_id):
        """Sets the paper_id of this PaperInfo.


        :param paper_id: The paper_id of this PaperInfo.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and paper_id is None:
            raise ValueError("Invalid value for `paper_id`, must not be `None`")  # noqa: E501

        self._paper_id = paper_id

    @property
    def url(self):
        """Gets the url of this PaperInfo.  # noqa: E501

        URL on the Semantic Scholar website  # noqa: E501

        :return: The url of this PaperInfo.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this PaperInfo.

        URL on the Semantic Scholar website  # noqa: E501

        :param url: The url of this PaperInfo.  # noqa: E501
        :type: str
        """

        self._url = url

    @property
    def title(self):
        """Gets the title of this PaperInfo.  # noqa: E501


        :return: The title of this PaperInfo.  # noqa: E501
        :rtype: str
        """
        return self._title

    @title.setter
    def title(self, title):
        """Sets the title of this PaperInfo.


        :param title: The title of this PaperInfo.  # noqa: E501
        :type: str
        """

        self._title = title

    @property
    def venue(self):
        """Gets the venue of this PaperInfo.  # noqa: E501


        :return: The venue of this PaperInfo.  # noqa: E501
        :rtype: str
        """
        return self._venue

    @venue.setter
    def venue(self, venue):
        """Sets the venue of this PaperInfo.


        :param venue: The venue of this PaperInfo.  # noqa: E501
        :type: str
        """

        self._venue = venue

    @property
    def year(self):
        """Gets the year of this PaperInfo.  # noqa: E501


        :return: The year of this PaperInfo.  # noqa: E501
        :rtype: int
        """
        return self._year

    @year.setter
    def year(self, year):
        """Sets the year of this PaperInfo.


        :param year: The year of this PaperInfo.  # noqa: E501
        :type: int
        """

        self._year = year

    @property
    def authors(self):
        """Gets the authors of this PaperInfo.  # noqa: E501


        :return: The authors of this PaperInfo.  # noqa: E501
        :rtype: list[object]
        """
        return self._authors

    @authors.setter
    def authors(self, authors):
        """Sets the authors of this PaperInfo.


        :param authors: The authors of this PaperInfo.  # noqa: E501
        :type: list[object]
        """

        self._authors = authors

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(PaperInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PaperInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PaperInfo):
            return True

        return self.to_dict() != other.to_dict()
