# coding: utf-8

"""
    Literature Graph Service

    Fetch paper and author data from the Semantic Scholar corpus  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from s2cholar.configuration import Configuration


class Reference(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'contexts': 'object',
        'intents': 'object',
        'is_influential': 'bool',
        'cited_paper': 'ReferenceCitedPaper'
    }

    attribute_map = {
        'contexts': 'contexts',
        'intents': 'intents',
        'is_influential': 'isInfluential',
        'cited_paper': 'citedPaper'
    }

    def __init__(self, contexts=None, intents=None, is_influential=None, cited_paper=None, _configuration=None):  # noqa: E501
        """Reference - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._contexts = None
        self._intents = None
        self._is_influential = None
        self._cited_paper = None
        self.discriminator = None

        if contexts is not None:
            self.contexts = contexts
        if intents is not None:
            self.intents = intents
        if is_influential is not None:
            self.is_influential = is_influential
        self.cited_paper = cited_paper

    @property
    def contexts(self):
        """Gets the contexts of this Reference.  # noqa: E501

        List of contexts  # noqa: E501

        :return: The contexts of this Reference.  # noqa: E501
        :rtype: object
        """
        return self._contexts

    @contexts.setter
    def contexts(self, contexts):
        """Sets the contexts of this Reference.

        List of contexts  # noqa: E501

        :param contexts: The contexts of this Reference.  # noqa: E501
        :type: object
        """

        self._contexts = contexts

    @property
    def intents(self):
        """Gets the intents of this Reference.  # noqa: E501

        List of intents  # noqa: E501

        :return: The intents of this Reference.  # noqa: E501
        :rtype: object
        """
        return self._intents

    @intents.setter
    def intents(self, intents):
        """Sets the intents of this Reference.

        List of intents  # noqa: E501

        :param intents: The intents of this Reference.  # noqa: E501
        :type: object
        """

        self._intents = intents

    @property
    def is_influential(self):
        """Gets the is_influential of this Reference.  # noqa: E501

        https://www.semanticscholar.org/faq#influential-citations  # noqa: E501

        :return: The is_influential of this Reference.  # noqa: E501
        :rtype: bool
        """
        return self._is_influential

    @is_influential.setter
    def is_influential(self, is_influential):
        """Sets the is_influential of this Reference.

        https://www.semanticscholar.org/faq#influential-citations  # noqa: E501

        :param is_influential: The is_influential of this Reference.  # noqa: E501
        :type: bool
        """

        self._is_influential = is_influential

    @property
    def cited_paper(self):
        """Gets the cited_paper of this Reference.  # noqa: E501


        :return: The cited_paper of this Reference.  # noqa: E501
        :rtype: ReferenceCitedPaper
        """
        return self._cited_paper

    @cited_paper.setter
    def cited_paper(self, cited_paper):
        """Sets the cited_paper of this Reference.


        :param cited_paper: The cited_paper of this Reference.  # noqa: E501
        :type: ReferenceCitedPaper
        """
        if self._configuration.client_side_validation and cited_paper is None:
            raise ValueError("Invalid value for `cited_paper`, must not be `None`")  # noqa: E501

        self._cited_paper = cited_paper

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Reference, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Reference):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Reference):
            return True

        return self.to_dict() != other.to_dict()
